#include "functions.h"
#include "ADXL345.h"
#include <Wire.h>
#include <SeeedOLED.h>
#include <avr/pgmspace.h>
#include <Sleep_n0m1.h>
#include "sleep.h"

void setup(void)
{
  Wire.begin();	
  SeeedOled.init();  //initialze SEEED OLED display
  SeeedOled.clearDisplay();  // clear the screen and set start position to top left corner
  Serial1.begin(38400);
  initIOs();
  //initADXL345();//init ADXL345 for auto restart
  analogReference(INTERNAL);
  analogRead(4);
}
void loop(void)
{
  unsigned char count=0;
  for(;;)
  {
    if(Serial1.available()) 
    {
      SeeedOled.setTextXY(5,0);
      while(Serial1.available())
      {
        char c = (char)Serial1.read();
        Serial.write(c);
        SeeedOled.putChar(c);
      }
      Serial1.println("OK");
    }

    unsigned char ChS=readCharge();
    if(ChS == DONE)
    {
      rLEDport &=~ rLEDbit;
    }
    else if(ChS == CHARGE)
    {
      rLEDport ^= rLEDbit;
    }
    else
    {
      rLEDport |= rLEDbit;
    }
    if(count>9)
    {
      count=0;
      readBat();      
      gLEDport &=~ gLEDbit;
      delay(100);
      gLEDport |= gLEDbit;
    }
    delay(100);
    count++;

    readAcc();//get new Acc
    Serial.print("X = ");
    Serial.print(Xg);
    SeeedOled.setTextXY(1,0);
    SeeedOled.putString("X= ");
    SeeedOled.setTextXY(1,3);
    SeeedOled.putFloat(Xg);
    SeeedOled.putString("    ");

    Serial.print(", Y = ");
    Serial.print(Yg);

    SeeedOled.setTextXY(2,0);
    SeeedOled.putString("Y= ");
    SeeedOled.setTextXY(2,3);
    SeeedOled.putFloat(Yg);
    SeeedOled.putString("    ");

    Serial.print(", Z = ");
    Serial.println(Zg);

    SeeedOled.setTextXY(3,0);
    SeeedOled.putString("Z= ");
    SeeedOled.setTextXY(3,3);
    SeeedOled.putFloat(Zg);
    SeeedOled.putString("    ");

    SeeedOled.setTextXY(4,0);
    SeeedOled.putString("BLE Connected");
  }
}

//=========================================
unsigned char readCharge(void)
{
  unsigned char Temp = CHRGpin & CHRGbit;
  if(!Temp)
  {
    return CHARGE;
  }
  Temp = DONEpin & DONEbit;
  if(!Temp)
  {
    return DONE;
  }
  return NONE;
}

//=========================================
unsigned char readBat(void)
{
  unsigned int rAD4 = analogRead(4);
  Serial.println(rAD4);
  SeeedOled.setTextXY(0,0);
  SeeedOled.putNumber(rAD4);
}

//=========================================
void initIOs(void)
{
  rLEDport |= rLEDbit;
  gLEDport |= gLEDbit;
  rLEDdir |= rLEDbit;
  gLEDdir |= gLEDbit;

  CHRGdir &=~ CHRGbit;
  CHRGport |= CHRGbit;
  DONEdir &=~ DONEbit;
  DONEport |= DONEbit;
}




















